#!/usr/bin/perl

############################################
#
# addpolarh.pl
#
# Uses pdbhadd to add hydrogens and then leaves only the
# polar H there.
#
# Usage: addpolarh.pl file
#
# CodeWithMe Productions 2000
############################################


use PDB_Parse  "PDB_Parse.pm";

%nterm = (
"H   " =>1,
"N   " =>1,
"CA  " =>1,
"C   " =>1,
"O   " =>1,
);
 
 %cterm = (
 "C   " =>1,
 "CA  " =>1,
 "H   " =>1,
 "N   " =>1,
 "O   " =>1,
 "OXT " =>1,
 );   

`hbplus -O $ARGV[0]`;
$_ = $ARGV[0];

s/\..*//s;

$out = $_.".h";

$pdb = new PDB_Parse($ARGV[0]);
$num_res = $pdb->{Record}->num_residues;
$init_res = $pdb->{Record}->residues(1)->number;
$ct_res = $pdb->{Record}->residues($num_res)->name;
$term_res = $pdb->{Record}->residues($num_res)->number;
$nt_res = $pdb->{Record}->residues(1)->name;
$nflag = 0;
$cflag = 0;


open (FILE, "$out") || die;
while(<FILE>){
   if(/^ATOM /){
        $atom = substr($_, 13, 4);
        $res  = substr($_, 17, 3);
        $res_num = substr($_, 22, 5); 
	$chain = substr($_,21,1);

	s/ $chain /   /s; #uhbd doesn't like chain thank you

	if($res_num == $term_res && $res =~ $ct_res){
		$res2 = 'CTRM';
		$cflag = 1;
	}elsif($res_num == $init_res  && $res =~ $nt_res){
		$res2 = 'NTRM';
		$nflag = 1;
	}

		if($nflag && exists($nterm{$atom})){
			s/1H  / HT1/s;
			s/2H  / HT2/s;
			s/3H  / HT3/s;
		#	s/$res /$res2/s;
		      }
	        #elsif($cflag && exists($cterm{$atom})){
		#	s/$res /$res2/s;
		#}
	if($res eq 'ASN'){
		s/1HD2 / HD21/s;
		s/2HD2 / HD22/s;
	}elsif($res eq 'ARG'){
		s/1HH1 / HH11/s;
		s/2HH1 / HH21/s;
		s/1HH2 / HH12/s;
		s/2HH2 / HH22/s;
	}elsif($res eq 'LYS'){
		s/1HZ / HZ1/s;
		s/2HZ / HZ2/s;
		s/3HZ / HZ3/s;
	}elsif($res eq 'GLN'){
		s/1HE2 / HE21/s;
		s/2HE2 / HE22/s;
	}
 
 	$atom = substr($_,13,4);
	s/$atom/$atom/s; #uhbd needs it's space thank you

	if($res ne 'HIS' || $atom ne 'HE2 '){
		print $_;
	}
	$nflag = 0;
	$cflag = 0;
   }
}


