#!/usr/bin/perl
#program to calculate molwts
#

# IN is the input file which is the first command line arguement

open (IN, $ARGV[0]) or die "Can't open file $ARGV[0]\n$!\n";

# Hash table to associate the three letter code to one letter code
%mol_wt=(
	ALA	=>	71.1,
	CYS	=>	103.2,
	ASP	=>	115.1,
	GLU	=>	129.1,
	PHE	=>	147.2,
	GLY	=>	57.1,
	HIS	=>	137.2,
	ILE	=>	113.2,
	LYS	=>	128.2,
	LEU	=>	113.2,
	MET	=>	131.2,
	ASN	=>	114.1,
	PRO	=>	97.1,
	GLN	=>	128.2,
	ARG	=>	156.2,
	SER	=>	87.1,
	THR	=>	101.1,
	VAL	=>	99.1,
	TRP	=>	186.2,
	TYR	=>	163.2
	   );


$mol_wt_sum=0;

while (<IN>)
{
  chop;
  if (/ CA /)   #Pull only entries that pertain to the sequence
  {
    @test=split /\s+/,$_;  #put entries is an array after removing white spaces
    $test=@test;   # get the length of the array
    for ($a=0;$a<$test;$a++)
    {
      $mol_wt_sum+=$mol_wt{@test[$a]};  #add weight
    }

  }
}

print "$ARGV[0] \t$mol_wt_sum \n";
close (IN); # Close the input file
