############################################################
#
#   predict.pl
#
#   Perl program for create clean file and vector for 
#   prediction.
#
#   Usage: ./predict.pl pdb_id's
#
#   CodeWithMe Production 2007
#   Shula Shazman
#   shulas@techunix.technion.ac.il
#
#
###########################################################
use LWP::Simple;

foreach $chain_filename (@ARGV){
	
	# fix PDB format into original version
	system '/usr/bin/perl fix_pdb.pl '.$chain_filename ;
	# create clean file
    system '/usr/bin/perl clean_pdb.pl '.$chain_filename.'.pdb >'.$chain_filename.'.clean';
    # create header for test file
    
   
    # get first patch parameters 
    system '/usr/bin/perl svm_ultimate_ex_cons.pl '.$chain_filename.'.clean   1 > '.$chain_filename.'log.txt';
    
       
    # get moment dipole parameters
    my $url = 'http://bip.weizmann.ac.il/dipol-bin/dipol2j.cgi?pdb_id='.$chain_filename.' &peps=y';
    my $content = get $url;
    die "Couldn't get $url" unless defined $content;
    open(FILE, ">$chain_filename.dipole");
    print FILE $content;
    close(FILE);
    #open (DEBUG, ">try.debug");
    #print DEBUG $chain_filename ,"\n";
    open IN , "$chain_filename.dipole" or die$!;
    $chain_temp ="";
    $found = 0;
    $counter = 0;
    @dipole_params = ();
	while (<IN>){
		$chain_id = "ChainID =  ".substr($chain_filename,4,1);
		if ($found == 0){
    		if ($_ =~ $chain_id) { $found = 1;}
    		else {next;}
    	}
    	else {if ($counter < 3){
    			$chain_temp = $chain_temp.$_;
    		 	$counter++;}}
	}
	open (TEST, ">>$chain_filename.clean.test");
	@dipole_params = split(/<TD align="right">/,$chain_temp);
			{print TEST substr($dipole_params[7], 0, -1),"\t";
			 print TEST substr($dipole_params[8],0,-1),"\t"};
	#print DEBUG $chain_temp;
    #my $url = 'http://www.rcsb.org/pdb/files/'.$pdb.'.pdb';
    close (TEST);
    # get second and third patches parameters
    `perl sum_res_patchIII.pl $chain_filename.clean 2`;
    `perl patchfinder_all.pl $chain_filename`;
    `perl proccess_atoms.pl $chain_filename`;
    `perl find_patches.pl $chain_filename`;
    `cat $chain_filename.patches >> $chain_filename.clean.test`;
    $pdb_name = substr($chain_filename,0,4);
    `cat $chain_filename.clean.test >> $pdb_name.test`;
    
    # run svm and get prediction results
   # `rm total.predict`;
    #`gist-classify -train NAbinding.mtx -learned NAbinding.weights -test $chain_filename.clean.test >> $chain_filename.predict`;
   # `cat $chain_filename.predict >> total.predict`;
    `perl rm.pl $chain_filename`;
}
