#!/usr/bin/perl

############################################3
#
#   svm_ultimate_ex_cons.pl 
#
#   Usage: svm_ultimate_ex_cons.pl file.pdb
#
#   CodeWithMe Productions 2001
############################################


use PDB_Parse "PDB_Parse.pm";


if($#ARGV != 1){
	print STDERR "Usage:svm_ultimate_ex_cons.pl pdbfile description\n";
	exit -1;
}


$file = $ARGV[0];
$desc = $ARGV[1];
$pdb = new PDB_Parse($ARGV[0]);
$pdb->use_dssp();
$num_res = $pdb->{Record}->num_residues;
#$res_name = $pdb->{Residue}->name;

%ss_hash = (
	"E" => 0,
	"B" => 0, 
	"H" => 1,
	"G" => 1,
	"T" => 2,
	"S" => 3,
	" " => 3
);

%residues = (
        "VAL"     =>     0,
        "ILE"     =>      1,
        "LEU"     =>      2,
        "ALA"     =>      3,
        "PHE"     =>      4,
        "TRP"     =>     5,
        "CYS"     =>      6,
        "GLY"     =>      7,
        "MET"     =>     8,
        "TYR"     =>     9,
        "PRO"     =>    10,
        "SER"     =>    11,
        "THR"     =>    12,
        "ASN"     =>     13,
        "GLN"     =>    14,
        "HIS"     =>     15, 
        "ASP"     =>     16,
        "GLU"     =>     17,
        "LYS"     =>     18,
        "ARG"     =>     19,
          );        

sub myprint{
  print STDERR $_[0];
  
  open (ULT, ">>$file.test") || die;
  #open (ADD, ">$file.new.test") || die;
  #open (SUM, ">>all.res") || die;
  $lysout = $#lys_out_arr;

print ULT "$file\t$desc\t$num_pts\t$sum_pot\t$#patch2arr\t$beta\t$helix\t$loop\t$sa\t$sa_res\t$rough_patch2\t$negpatch\t$res_lysout\t$lys\t$arg\t$pol\t$mw_res\t$pat_radgyr\t$normal_radgyr\t$sa_prot\t$mw\t$cleft1\t$cleft2\t$cleft3\t$patch_surf\t$acc\t$donor\t$acchit\t$donhit\t$per_hb\t";

#print ADD "$extend\t$extend_prot\t$extend_term\t$ex_loop\t$lys_in_loop\t$lys_in_ex\t$lys_in_term\t$arg_in_term\n";
}

open (PATCH2, ">$file.patch2_res") || die or $!;

print STDERR "DON'T FORGET YOUR QTABLE.DAT FILE TO BE PLACED IN THE LOCAL DIRECTORY\n";

#use uhbd and get patch2 residues
$patch2 = `perl sum_res_patchIII.pl $file 2`;
@patch2arr = split(/\t/,$patch2);
print PATCH2 $patch2;

#patch evaluation
$patch_eval = `perl patch_eval.pl $file.patch2`;
@patch_eval = split(/\t/,$patch_eval);
$num_pts = $patch_eval[1];
$sum_pot = $patch_eval[2];
$avg_pot = $patch_eval[3];
chomp $sum_pot;

#terminal boundaries
$terminal = `perl terminal.pl $file`;

##########################################
#
#   ss_patch.pl
#
#   Description: ss_patch gives you the secondary 
#	structure associated with a patch from patchfiner.
###########################################


$_ = $patch2;
	@arr = split;

	
	for($i=0;$i<=3;$i++){
		$ss_type[$i] = 0;
	}

	for($i=1;$i<=$#arr;$i++){
		$res_num = substr($arr[$i],3,4);
		@ss = $pdb->return_res_num($res_num);
		$ss = $ss[0]->structure;
		if(exists($ss_hash{$ss})){
			$id = $ss_hash{$ss};
			$ss_type[$id]++;
		}
	}

        $sum = $ss_type[0] + $ss_type[1] + $ss_type[2] + $ss_type[3];
        if ($sum != 0){
	    $beta= sprintf ("%3.4f", $ss_type[0]/$sum);
	    $helix= sprintf("%3.4f",$ss_type[1]/$sum);
	    $loop=  sprintf("%3.4f",($ss_type[2]+$ss_type[3])/$sum);
	    $extend= sprintf("%3.4f",($ss_type[3])/$sum);}

	for($i=0;$i<$#ss_type;$i++){
	    if ($sum != 0){$add = sprintf("%3.4f\t",$ss_type[$i]/$sum);}
		$ss_patch2 = $ss_patch2.$add;
	}

	if($sum != 0){ 
	   $add = sprintf("%3.4f",$ss_type[$i]/$sum);
	}else{
	   print "SA sum = 0\n";
	}

	$ss_patch2 = $ss_patch2.$add;

#########################################
#
#   ss_terminal.pl
#
##########################################
$lys_term = 0;
$lys_loop = 0;
$arg_term = 0;

$_ = $terminal;
        @arr = split;

	for($i=0;$i<=3;$i++){
		$ss_term[$i] = 0;
	}

	for($i=0;$i<=$#arr;$i++){
		$res_num = $arr[$i];
		@ss = $pdb->return_res_num($res_num);
		$ss = $ss[0]->structure;
		$name = $ss[0]-> name;
		
		if(exists($ss_hash{$ss})){
			$id = $ss_hash{$ss};
			$ss_term[$id]++;
		}
		if($residues{$name}==18){
		      $lys_term++;
		      }
		if($residues{$name}==19){
		      $arg_term++;
		      }

	}

        $sum_term = $ss_term[0] + $ss_term[1] + $ss_term[2] + $ss_term[3];
        $beta_term= sprintf ("%3.4f", $ss_term[0]/$sum_term);
	    $helix_term= sprintf("%3.4f",$ss_term[1]/$sum_term);
        $loop_term=  sprintf("%3.4f",($ss_term[2]+$ss_term[3])/$sum_term);
        $extend_term= sprintf("%3.4f",($ss_term[3])/$sum_term);
        $lys_in_term = sprintf("%3.4f",($lys_term/40));
        $arg_in_term =sprintf("%3.4f",($arg_term/40));

        $start = $arr[0];
        $end = $arr[$#arr-1];

	for($i=$start;$i<$end;$i++){
		$res_num = $i;
		@ss = $pdb->return_res_num($res_num);
		$ss = $ss[0]->structure;
		$name = $ss[0]-> name;
		$res_id = $residues{$name};
		if(exists($ss_hash{$ss})){
			$id = $ss_hash{$ss};
			$ss_prot[$id]++;
		}

		if ((($id==2) || ($id ==3)) && ($res_id==18)){
		  $lys_loop++;
		}
	}
        $sum_prot = $ss_prot[0] + $ss_prot[1] + $ss_prot[2] + $ss_prot[3];
        $beta_prot= sprintf ("%3.4f", $ss_prot[0]/$sum_prot);
	    $helix_prot= sprintf("%3.4f",$ss_prot[1]/$sum_prot);
        $loop_prot=  sprintf("%3.4f",($ss_prot[2]+$ss_prot[3])/$sum_prot);
        $extend_prot= sprintf("%3.4f",($ss_prot[3])/$sum_prot);
        $ex_loop = sprintf("%3.4f",($ss_prot[3])/($ss_prot[2]+$ss_prot[3]));
        $lys_in_loop = sprintf("%3.4f",($lys_loop)/($ss_prot[2]+$ss_prot[3]));
        $lys_in_ex = sprintf("%3.4f",($lys_loop)/($ss_prot[3]));




##########################################
#   sa_patch.pl
#
#   Description: sa_patch gives you the surface 
#	area associated with a patch from patchfiner.
###########################################

$_ = $patch2;
	@arr = split;
	$sa = 0;

	for($i=1;$i<=$#arr;$i++){
		$res_num = substr($arr[$i],3,4);
		@sa = $pdb->return_res_num($res_num);
		if($sa[0] != ''){
		   $sa += $sa[0]->sa;
		}
	}
	if($#arr == 0){push(@arr,0);}	
	$sa_patch2 =  sprintf("%3.3f\t%3i\t%3.3f\t",$sa, ($#arr), $sa/$#arr);
        $sa_res= sprintf ("%3.3f",$sa/$#arr);

print "SA_PATCH=$sa_patch2\n";

##########################################
#   rough_patch.pl
#   
#   Hit a rough patch?
#
#   Description: rough_patch gives you the roughness 
#	associated with a patch from patchfiner.
###########################################

$_ = $patch2;
	@arr = split;
	
	open(OUT, ">rough.tmp")|| die;
	foreach $probe (1, 1.25, 1.5, 1.75, 2){
	   $sa_patch = 0;
           $pdb->calc_sa($probe);
	   for($i=1;$i<=$#arr;$i++){
		$res_num = substr($arr[$i],3,4);
		$sa_patch += $pdb->sum_SA($pdb->return_res_num($res_num));
	   }
	    print OUT "$probe ",$sa_patch, "\n";
	}

$rough_patch2 = `roughpatch.csh rough.tmp`;
chomp $rough_patch2;

print "Rough_patch = $rough_patch2\n";

close(OUT);

##########################
# Get negative patch2 data
##########################
open(NEG,">$file.negpatch2_res");
$neg_patch2 = `perl sum_neg_patchIV.pl $file -2`;
@neg_array = split(/\t/,$neg_patch2);
$negpatch = $#neg_array;
print NEG $neg_patch2;

###########################################
# Get the radius of gyration of the patch.
###########################################

$radgyr = `perl radgyr_patch.pl $file.patch2_res`;
@radgyr = split(/\t/,$radgyr);
$reg_radgyr = $radgyr[1];
$pat_radgyr = $radgyr[2];
$normal_radgyr = $radgyr[3];
chomp $normal_radgyr;
 
##########################
# Caluclate with lys out.
##########################
$lys=0;
$arg=0;
$pol=0;

open(LYSOUT,">$file.lysout_res");
$lys_out1 = `perl lys_outII.pl $file 2`;

@lys_out_arr = split(/\t/,$lys_out1);
print LYSOUT $lys_out1;
  
@arr = @lys_out_arr;
print $#arr ,"== lysoutarraysize\n";
$res_lysout = $#arr;

for($i=0; $i<=$#arr; $i++){
	$qres = substr($arr[$i],0,3);
	$num = $residues{$qres};
	if($num == 18){
		$lys++;
	}elsif($num == 19){
		$arg++;
	}elsif($num <18 && $num >10){
		$pol++;
	}
}
print "LYSOUT $lys $arg $pol\n";
`compress -f $file.phi`;
`compress -f $file.dms`;

#################
#calculate hbons#
#################

$hbonds = `perl patch_hbonding_svm_ult.pl $file`;
@hbonds = split(/\s+/,$hbonds);

$acc = $hbonds[0];
$donor = $hbonds[1];
$acchit = $hbonds[2];
$donhit = $hbonds[3];
$per_hb = $hbonds[4];

chop $per_hb;

print "Percent HB= ".$per_hb."\n";


######################
#calculate surf_patch#
######################

`mask_in_svm_ult.sh $file`;
@cleft_surf = split (/\s+/,`cat surf.out`);

$cleft1 = $cleft_surf[0];
$cleft2 = $cleft_surf[2];
$cleft3 = $cleft_surf[4];

#chop $cleft3;

$patch_surf = `cat surf_patch.res`;
  
chomp $patch_surf;
print "Patch-Surf overlap =".$patch_surf."\n";

#######################
# calculate patch_cons#
#######################

#`perl patch_loop_ult.pl $file`;
#$patch_cons = `cat patch_cons.res`;
#$patch_cons2 = `cat patch_cons.res2`;
#$all_patch = `cat all_patch_cons`;
#$loop_patch_cons = `cat loop_patch_cons.res`;
#$loop_patch_cons2 = `cat loop_patch_cons.res2`;

#chomp $loop_patch_cons;
#chomp $loop_patch_cons2;
#chomp $patch_cons;
#chomp $patch_cons2;
#chomp $all_patch;

#if ($patch_cons =~ " ") {
#  print "DIDN'T CALCULATE CONSERVATION: NO ALIGNMENT\n";
#}
#else {
#  print "percent conservation (positive,arginine, aromatics)=".$patch_cons."\n";
#} 


open(TMP, ">ul_tmp");

#for_mw
   print "MWcall\n";
   $_ =  `perl mol_wt.pl $file `;
   /(\w+)\W+(\d+)/;
   $mw = $2;
   chomp $mw;
   print "MW == $mw\n";

#for_SA
print TMP `calc-surface.exe <$file >ul_tmp`;
close(TMP);
$sa_protein = `perl sum.pl ul_tmp`;
chomp $sa_protein;
$sa_prot = sprintf ("%4.2f",$sa_protein);
print "SA == $sa_prot\n";


$mw_res = sprintf("%3.4f",$mw/$num_res);

myprint();

`clean.sh $file`;
