############################################################
#
#   rna_binding_prediction.pl
#
#   Perl program for prediction RNA binding function.
#
#   Usage: ./rna_binding_prediction.pl pdb_id's
#
#   CodeWithMe Production 2007
#   Shula Shazman
#   shulas@techunix.technion.ac.il
#
###########################################################
#!/usr/bin/perl
 
use LWP::Simple;

# get the pdb file from rcsb

foreach $pdb (@ARGV){
   my $chain_file_name=" ";
   $pdb =~ tr/a-z/A-Z/; #translate to all upper case
   my $url = 'http://www.rcsb.org/pdb/files/'.$pdb.'.pdb';
   my $content = get $url;
   die "Couldn't get $url" unless defined $content;
   s/.*\nHEADER /HEADER /s; #parse actual pdb file
   s/\nEND .*/\nEND/s;
   $pdb =~ tr/A-Z/a-z/; #translate back
   #check to see if it got it
   if(substr($content, 0, 6) =~ "HEADER"){
      open(FILE, ">$pdb.pdb");
      print FILE $content;
      close(FILE);
   }
   else{
   	  print "Can't find pdb$pdb.ent \n";
   }
   open FILE, "$pdb.pdb" or die $!;
   
   # create test file
   open (TEST, ">>$pdb.test");
   print TEST "file\tdesc\tpatch_size\tpatch_potential\tpatch_residue\tbeta\thelix\tloop\tpatch_surface_accessibility\tsurface_accessibility_per_residue\tpatch_roughness\tnegative_patch\tlysout_residue\tlys\targ\tpol\tmw_res\tgyration_radius\tnormal_gyration_radius\tprotein_surface_accessibility\tmw\tcleft1\tcleft2\tcleft3\tpatch_surf_overlap\tacceptor\tdonor\tacchit\tdonhit\thydrogene_bond_percent\tDipole\tQuadrapole\tpatch1_atoms\tpatch2_atoms\tpatch3_atoms\tneg_patch_atoms\tdistance_12\tdistance_13\tdistance_23\tdistance_1_neg\tdistance_2_neg\tdistance_3_neg\n";
   close(TEST);
   
   # split the pdb file into seperate pdb files of chains
   while (<FILE>) {
   	if (substr($_,0,6) eq "ENDMDL") {last} ;   # for NMR files
	if(!(substr($_,0,6) eq "ATOM  ")){ next};
    if (substr($_,17,1) eq " "){print CLEAN $_, "\n";next} ;   # create chain files just for proteins not RNA  			
			# open file for first chain
			if ($flag == 0){						 
				$flag = 1;	
				$last = substr($_,21,1);
				if ($last eq " ") {$last = "_"} ;
				$filename = "$pdb"."$last.pdb";
        		open(OUT,">>$filename")or die$! ;
        		#print $filename , , "\n","44444============================================\n"
        		}
			else    
			
			{
                $current = substr($_,21,1);
		        if ($current eq " ") {$current = "_"} ;
			   
			   # finish proccess current chain and start a new chain
			    if (!($current eq $last)){						
					$filename = "$pdb"."$last";
                	close(OUT);
                	#if(!(substr($filename,4,1)eq " ")){
                		#print $filename , "\n","11111============================================\n";
                		system '/usr/bin/perl predict.pl '.$filename;	 
               		if ($firstChain == 1){$firstChain=0;}
               		$last = $current; 
				 	my $filename = "$pdb"."$last.pdb";
        		 	open(OUT,">>$filename")or die$! ;}
			}

		print OUT $_;}
    # finish proccess last chain
	close(OUT);
	$filename = "$pdb"."$last";
	if(!(substr($filename,4,1)eq "")){
		#print $filename , "\n","2222=================================================\n";
		system '/usr/bin/perl predict.pl '.$filename;}	 	
	    


#print $pdb ,"\n","0000000000000000000000000000000000000000000000000000000\n";
system 'rm '.$pdb.'.pdb';

# run svm and get prediction results

`gist-classify -train RNAbinding.mtx -learned RNAbinding.weights -test $pdb.test >> $pdb.predict`;
`cat $chain_filename.predict >> $pdb.predict`;

open TOTAL , "$pdb.predict" or die$!;
    while (<TOTAL>){
    	print $_;}
close (TOTAL);
}